# Le DNS

Le DNS (Domain Name System) est un système de distribution d'informations correspondant à des noms de domaines. Il est notamment utilisé pour obtenir des adresses IP à partir d'un nom de domaine, mais peut servir à obtenir n'importe quelle information suffisamment courte à partir d'un nom de domaine.

1. Le client DNS demande l'adresse IPv6 de `fr.wikipedia.org.` à un résolveur DNS récursif
2. Le résolveur DNS récursif demande l'adresse de `fr.wikipedia.org.` à `.`, l'un serveur racine.
3. Le serveur racine ne connait pas cette information, mais il sait comment s'en rapprocher : il répond l'adresse du serveur qui gère `org.`.
4. Le résolveur DNS récursif demande l'adresse de `fr.wikipedia.org.` au serveur de `org.`
5. Le serveur qui gère `org.` n'a pas cette information, mais sait comment s'en rapprocher et répond l'adresse du serveur qui gère `wikipedia.org.`.
6. Le résolveur DNS récursif demande l'adresse de `fr.wikipedia.org.` au serveur qui gère `wikipedia.org.`.
7. Cette information se trouve directement dans la zone servie par ce serveur, il lui répond donc l'adresse IPv6 de `fr.wikipedia.org.`.
8. Le résolveur DNS récusif répond finalement l'adresse IPv6 reçue au client DNS qui avait initié la demande.

## Les enregistrements DNS

Un enregistrement DNS est composé de plusieurs parties :

```
<domaine> <classe> <type> <ttl> <contenu>
```

`<domaine>`
: Le domaine concerné par l'enregistrement

`<classe>`
: Toujours IN (pour Internet)

`<type>`
: Le type de donnée contenue, voir description des types possible après dans la page

`<ttl>`
: Temps pendant lequel l'enregistrement peut être gardé en cache
  [Explications détaillées](ttl.md)

`<contenu>`
: Dépends du type d'enregistrement

## Les enregistrements multiples

Il peut exister plusieurs valeurs pour un même type d'enregistrement et même domaine.

Ainsi, il est probable que le résolveur reçoivent plusieurs adresses de serveurs ayant autorité pour un domaine ou que le client recoive plusieurs adresses IPv6 pour le domaine demandé ; le résolveur ou le client n'utilisera alors généralement qu'une seule de ces adresses, choisie aléatoirement. Si jamais l'adresse ne fonctionne pas, l'une des autres adresses reçues sera essayée, ce qui permet une meilleure résistance aux pannes de serveurs.

## Types d'enregistrements

[NS](record-ns.md)
: Serveurs ayant autorité

[A et AAAA](record-ip.md)
: Adresse IP

[TXT](record-txt.md)
: Texte

[CAA](record-caa.md)
: Autorités de certification autorisées à émettre des certificats

[SRV](record-srv.md)
: Adresse d'un service

[MX](record-mx.md)
: Serveur recevant les courriels

[SSHFP](record-sshfp.md)
: Empreinte des clé SSH

[TLSA](record-tlsa.md)
: DANE : Empreinte d'un certificat TLS

[CNAME](record-cname.md)
: Nom canonique

[DNAME](record-dname.md)
: Arbre canonique

[LOC](record-loc.md)
: Coordonnées géographiques
